/****************************************************************************

	LinePicker Class
	Copyright (C) 2009 Andre Deperrois adeperrois@xflr5.com

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation; either version 2 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA

*****************************************************************************/

#ifndef LINEPICKERDLG_H
#define LINEPICKERDLG_H

#include <QDialog>
#include <QComboBox>
#include "LineBtn.h"
#include "LineCbBox.h"
#include "LineDelegate.h"

class LinePickerDlg : public QDialog
{
	Q_OBJECT

public:
    LinePickerDlg(QWidget *pParent);

	void initDialog();
	void initDialog(int style, int width, QColor color);

	void keyPressEvent(QKeyEvent *event);

	int &width();
	int &setStyle();
	QColor &setColor();

	void setColor(QColor color);
	void setWidth(int width);
	void setStyle(int style);

	void fillBoxes();
	void setupLayout();


protected:
	LineBtn *m_pctrlColor;
	LineCbBox *m_pctrlWidth, *m_pctrlStyle;
	QPushButton *OKButton, *CancelButton;

private:
	int m_Style;
	int m_Width;
	QColor m_Color;
	void* m_pParent;
	LineDelegate *m_pStyleDelegate, *m_pWidthDelegate;


private slots:
	void onWidth(int val);
	void onStyle(int val);
	void onColor();

};

#endif // LINEPICKERDLG_H
